% function [MAE,SAE,density,B_nonocc,B_nontex,B_disc,disp] = compute_disparity(sname,fname,n_scales,thr)

% function [MAE,SAE,B_nonocc,B_nontex,B_disc,disp] =
% compute_disparity(sname,fname,n_scales,thr)
%  
% sname -> sequence name
% fname -> filter name
%
% RMS (root mean squared error) evaluated in textured, continuous and
% non-occluded regions
clear all
sname='venus';
path='/home/PSPC/manuela/disparity_and_flow_sent_out_14_06_2006.tar/disparity_and_flow_sent_out_14_06_2006/libs/disparity/';
eval(['load ' [path sname] ' I_l I_r depth_discont occl textureless truedisp;']);

sname2='./alg_comparison/';
load([sname2 sname 'ROT__WTA_5_sub5.mat'])
disp=(D(:,:,1));
if strcmp(sname,'tsukuba')
  disp(:,[1:18 367:end]) = [];
  disp([1:18 271:end],:) = [];
  truedisp(:,[1:18 367:end]) = [];
  truedisp([1:18 271:end],:) = [];
  depth_discont(:,[1:18 367:end]) = [];
  depth_discont([1:18 271:end],:) = [];
  occl(:,[1:18 367:end]) = [];
  occl([1:18 271:end],:) = [];
  textureless(:,[1:18 367:end]) = [];
  textureless([1:18 271:end],:) = [];
end
% if strcmp(sname,'venus')
%   disp(:,[1:10 end-9:end]) = [];
%   disp([1:10 end-9:end],:) = [];
%   truedisp(:,[1:10 end-9:end]) = [];
%   truedisp([1:10 end-9:end],:) = [];
%   depth_discont(:,[1:10 end-9:end]) = [];
%   depth_discont([1:10 end-9:end],:) = [];
%   occl(:,[1:10 end-9:end]) = [];
%   occl([1:10 end-9:end],:) = [];
%   textureless(:,[1:10 end-9:end]) = [];
%   textureless([1:10 end-9:end],:) = [];
% end



err = double( (abs(disp-truedisp) > 1) | isnan(disp) );


B_nonocc = 100 * (sum(err(~logical(occl))) ./ sum(1-occl(:)));
B_nontex = 100 * (sum(err(logical(textureless))) ./ sum(textureless(:)));
B_disc = 100 * (sum(err(logical(depth_discont))) ./ sum(depth_discont(:)));


err_mask = (~logical(textureless)) & (~logical(occl)) & ...
    (~logical(depth_discont));

AE = abs(disp - truedisp);
AE(~err_mask) = [];

valid = ~isnan(AE);

density = 100 * sum(valid) ./ numel(AE);

MAE = mean(AE(valid));
SAE = std(AE(valid));
stat(3)=density;
stat(1)=MAE;
stat(2)=SAE;
stat