%Test function that show the estimation of 2D disparity with the distributed code
%
% Authors:
% PSPC-lab - Biophysical and Electronic Engineering Department - University of Genoa
% March 2009 
clear
close all
a           = 0.5;      %ocular dominance (equal weight to the two eyes)
n_scales    = 5;        %number of scales
energy_th   = 1e-5;     %monocular energy threshold
n_filters   = 8;        %number of filter in space
ori_thr     = 0;        %threshold on orientation (0 if not used)

%test sequence
in_file     = './venus.mat';
out_file    = './alg_comparison/venus.mat';

load(in_file);



II(:,:,1)   = I_l;
II(:,:,2)   = I_r;



%phase shift
disp1=-1.5:0.5:1.5; %disparity range. Changing the range and the step means changing the number of cells in the population
		    %Note that the resulting phase shifts must be between -pi and pi
fo=1/4;         %Gabor filter frequency
ph_shift=-2*pi*(fo)*disp1; %phase shifts



profile off
profile on
D = disparity_population_code(II, n_scales, n_filters, energy_th, ori_thr, ph_shift,disp1, a);
profile off
profview

save(out_file, 'D')

subplot(221);
imagesc(I_l)

subplot(222);
imagesc(I_r)

subplot(223);
imagesc(D(:,:,1))

subplot(224);
imagesc(D(:,:,2))
